//
#include "LedSystem.h"
//
CLedSystem::CLedSystem(int pin)
{
  FPin = pin;
  FState = "Undefined";
  FCount = 0;
  FPeriod = 1000;
  FWidth = 500;
}
//
String CLedSystem::GetState(void)
{
  return FState;
}
//
bool CLedSystem::Open(void)
{
  pinMode(FPin, OUTPUT);
  SwitchOff();
  return true;
}
bool CLedSystem::Close(void)
{
  SwitchOff();  
  FState = "Undefined";
  pinMode(FPin, INPUT);
  return true;
}
//
void CLedSystem::SwitchOn(void)
{
  digitalWrite(FPin, HIGH);
  FState = "On";
}
void CLedSystem::SwitchOff(void)
{
  digitalWrite(FPin, LOW);
  FState = "Off";
}
void CLedSystem::Blink(long unsigned count, 
                       long unsigned period,
                       long unsigned width)
{
  
  if (0 < count)
  {
    FCount = count;
    FPeriod = period;
    FWidth = width;
    FMillisPreset = FWidth + millis();
    SwitchOn();
  }
}
//
bool CLedSystem::Execute(void)
{
  if (0 < FCount)
  {
    if (0 == strncmp("On", GetState().c_str(), 2))
    {
      if (FMillisPreset <= millis())
      {
        FMillisPreset = (FPeriod - FWidth) + millis();
        SwitchOff();
      }
    }
    else      
    if (0 == strncmp("Off", GetState().c_str(), 3))
    {
      if (FMillisPreset <= millis())
      {
        FCount--;
        if (0 < FCount)
        {
          FMillisPreset = FWidth + millis();
          SwitchOn();
        }
      }
    }    
  }
  return (0 < FCount);
}
//
